package com.rjconsultores.ventaboletos.web.utilerias.render;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import org.zkoss.util.media.AMedia;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Filedownload;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Button;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

import com.rjconsultores.ventaboletos.entidad.SolicitudExpreso;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.gui.controladores.expressos.DocumentosExpresosController;
import com.rjconsultores.ventaboletos.web.gui.controladores.expressos.ExpressosPorCotizarController;
import com.rjconsultores.ventaboletos.web.utilerias.PantallaUtileria;

public class RenderDocumentosExpresos implements ListitemRenderer {
	
	private SolicitudExpreso expreso;
	
	DocumentosExpresosController winDocumentosExpresosController;
	
	public RenderDocumentosExpresos(DocumentosExpresosController window) {
		super();
		winDocumentosExpresosController = window;
	}

	@Override
	public void render(Listitem item, Object data) throws Exception {
		SolicitudExpreso expresos = (SolicitudExpreso) data;
		
		Listcell lc = new Listcell(expresos.getSolicitudExpresoId().toString());
		lc.setParent(item);
		
		lc = new Listcell(DateUtil.getStringDate(expresos.getFechaSolicitud(), "dd/MM/yyyy"));
        lc.setParent(item);
        
        String ruta = expresos.getCiudadOrigen().getNombciudad() + " - " + expresos.getCiudadDestino().getNombciudad();
        lc = new Listcell(ruta);
        lc.setParent(item);
        
        if(expresos.getIndViajeRedondo() == false) {
        	lc = new Listcell(Labels.getLabel("expresosController.lbl.ida"));
            lc.setParent(item);
        }else if (expresos.getIndViajeRedondo() == true) {
        	lc = new Listcell(Labels.getLabel("expresosController.lbl.idaVuelta"));
            lc.setParent(item);
        }else {
        	lc = new Listcell();
            lc.setParent(item);
        }
        
        
        lc = new Listcell(DateUtil.getStringDate(expresos.getFechaHoraIda(), "dd/MM/yyyy HH:mm"));
        lc.setParent(item);
        
        lc = new Listcell(DateUtil.getStringDate(expresos.getFechaHoraRegreso(), "dd/MM/yyyy HH:mm"));
        lc.setParent(item);
        
        lc = new Listcell(expresos.getDescSitioPartidaIda());
        lc.setParent(item);
        
        lc = new Listcell(expresos.getDescSitioPartidaRegreso());
        lc.setParent(item);
        
        if(expresos.getIndRequiereDispVehiculo() == 0) {
        	lc = new Listcell("No");
            lc.setParent(item);
        }else if (expresos.getIndRequiereDispVehiculo() == 1) {
        	lc = new Listcell("Sí");
            lc.setParent(item);
        }else {
        	lc = new Listcell("N/A");
            lc.setParent(item);
        }
        
        lc = new Listcell();
        lc.setParent(item);
        
        Button btnVerContrato = new Button(Labels.getLabel("expresosController.lbl.btnVerContrato"));
        btnVerContrato.addEventListener("onClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				Listitem listItem = (Listitem) event.getTarget().getParent().getParent();
				expreso = (SolicitudExpreso)listItem.getAttribute("data");
				
				AMedia amedia = new AMedia("contrato.pdf", "pdf", null, expreso.getDocContrato());
				
				org.zkoss.util.media.Media pdf = amedia;
				Filedownload.save(pdf);
			}
		});
        lc.appendChild(btnVerContrato);
        
        Button btnVerFuec = new Button(Labels.getLabel("expresosController.lbl.btnVerFuec"));
        btnVerFuec.addEventListener("onClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				Listitem listItem = (Listitem) event.getTarget().getParent().getParent();
				expreso = (SolicitudExpreso)listItem.getAttribute("data");
			}
		});
        lc.appendChild(btnVerFuec);
        
        Button btnVerPlanilla = new Button(Labels.getLabel("expresosController.lbl.btnVerPlanilla"));
        btnVerPlanilla.addEventListener("onClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				Listitem listItem = (Listitem) event.getTarget().getParent().getParent();
				expreso = (SolicitudExpreso)listItem.getAttribute("data");
			}
		});
        lc.appendChild(btnVerPlanilla);
        
        Button btnVerListaPasajeros = new Button(Labels.getLabel("expresosController.lbl.btnVerListaPasajeros"));
        btnVerListaPasajeros.addEventListener("onClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				Listitem listItem = (Listitem) event.getTarget().getParent().getParent();
				expreso = (SolicitudExpreso)listItem.getAttribute("data");
			}
		});
        lc.appendChild(btnVerListaPasajeros);
		
		item.setAttribute("data", expresos);
	}

}
